/* Routines for Data Manipulation */


int max (int one, int two)
  {
  if (one >= two) return one;
  return two;
  }

/* returns the # of milliseconds since some constant time in the past */
long getMS(void)
  {
  struct timeval tv;
  struct timezone tz;

  gettimeofday(&tv,&tz);
  return tv.tv_sec*1000 + tv.tv_usec/(long)1000;
  }
  
void checkTime(void)
  {
  long currentTime = getMS();

  if ((currentTime-searchStartTime)>TIME)
    if (TIME>0)
      TIMEUP=TRUE;
  }


void initGame(void)
  {
  strcpy(game.event, "Computer Chess Game");
  strcpy(game.site, "P166MMX 48M Linux PC");
  game.round = 1;
  strcpy(game.white, "Unknown");
  strcpy(game.black, ProgramName);
  game.whiteELO=0;
  game.blackELO=0;
  strcpy(game.result, "?-? {Unknown}");
  game.gameTime = 2;
  game.gameInc = 12;
  game.numMoves = 0;
  game.myTime = 1000;
  game.oppTime = 1000;
  }

/* Takes all the pieces off,.. used during setup of a FEN position */
void clearBoard(void)
  {
  int i,j;

  for (i=0;i<8;i++)
    for (j=0;j<8;j++)
      pos.board[i][j].piece=EMPTY;

  /* now set all the piece flags */
  for (i=0;i<8;i++)
    {
    pos.wPawn[i] = 0;
    pos.bPawn[i] = 0;
    }
  pos.wcastle = FALSE;
  pos.bcastle = FALSE;
  pos.wKing = -1;
  pos.bKing = -1;
  pos.wqRook = -1;
  pos.bqRook = -1;
  pos.wkRook = -1;
  pos.bkRook = -1;
  pos.movenum = 1;     
  pos.ippawn = -1;
  pos.wKingRow=0;
  pos.wKingColumn=4;
  pos.bKingRow=7;
  pos.bKingColumn=4;
  }

/* Sets up the global position to the starting game position */
void initBoard(void)
  {
  int i,j = 0;

  pos.who_moves=WHITE;
  for (i=0; i<8; i++)
    {
    pos.board[1][i].colour = WHITE;
    pos.board[1][i].piece = PAWN;
    pos.board[6][i].colour = BLACK;
    pos.board[6][i].piece = PAWN;
    }
  pos.board[0][0].colour = WHITE;
  pos.board[0][0].piece = ROOK;
  pos.board[0][1].colour = WHITE;
  pos.board[0][1].piece = KNIGHT;
  pos.board[0][2].colour = WHITE;
  pos.board[0][2].piece = BISHOP;
  pos.board[0][3].colour = WHITE;
  pos.board[0][3].piece = QUEEN;
  pos.board[0][4].colour = WHITE;
  pos.board[0][4].piece = KING;
  pos.board[0][5].colour = WHITE;
  pos.board[0][5].piece = BISHOP;
  pos.board[0][6].colour = WHITE;
  pos.board[0][6].piece = KNIGHT;
  pos.board[0][7].colour = WHITE;
  pos.board[0][7].piece = ROOK;
  pos.board[7][0].colour = BLACK;
  pos.board[7][0].piece = ROOK;
  pos.board[7][1].colour = BLACK;
  pos.board[7][1].piece = KNIGHT;
  pos.board[7][2].colour = BLACK;
  pos.board[7][2].piece = BISHOP;
  pos.board[7][3].colour = BLACK;
  pos.board[7][3].piece = QUEEN;
  pos.board[7][4].colour = BLACK;
  pos.board[7][4].piece = KING;
  pos.board[7][5].colour = BLACK;
  pos.board[7][5].piece = BISHOP;
  pos.board[7][6].colour = BLACK;
  pos.board[7][6].piece = KNIGHT;
  pos.board[7][7].colour = BLACK;
  pos.board[7][7].piece = ROOK;
  /* set the rest of the squares to empty */
  for (i=2; i<6; i++)
    {
    for (j=0; j<8; j++)
      {
      pos.board[i][j].colour = WHITE;  /* just so it has a value */
      pos.board[i][j].piece = EMPTY;
      }
    }
  /* now set all the piece flags */
  for (i=0;i<8;i++)
    {
    pos.wPawn[i] = 0;
    pos.bPawn[i] = 0;
    }
  pos.wcastle = FALSE;
  pos.bcastle = FALSE;
  pos.wKing = 0;
  pos.bKing = 0;
  pos.wqRook = 0;
  pos.bqRook = 0;
  pos.wkRook = 0;
  pos.bkRook = 0;
  pos.movenum = 1;     /* we're ready for the first move! */
  pos.ippawn = -1;
  pos.wKingRow=0;
  pos.wKingColumn=4;
  pos.bKingRow=7;
  pos.bKingColumn=4;
  }

void initPCSQ(void)
  {
  int i,j;

  for (i=0;i<8;i++)
    for (j=0;j<8;j++)
      {
      pcsq[WHITE][0][i][j] = wPawn[i][j];
      pcsq[BLACK][0][i][j] = bPawn[i][j];
      pcsq[WHITE][1][i][j] = wKnight[i][j];
      pcsq[BLACK][1][i][j] = bKnight[i][j];
      pcsq[WHITE][2][i][j] = wBishop[i][j];
      pcsq[BLACK][2][i][j] = bBishop[i][j];
      pcsq[WHITE][3][i][j] = wRook[i][j];
      pcsq[BLACK][3][i][j] = bRook[i][j];
      pcsq[WHITE][4][i][j] = wQueen[i][j];
      pcsq[BLACK][4][i][j] = bQueen[i][j];
      pcsq[WHITE][5][i][j] = wKing[i][j];
      pcsq[BLACK][5][i][j] = bKing[i][j];
      }
  }

/* This is called when the endgame commences & alters the king tables. 
 * winning is the colour of the winning side.
 */

void setupKingPCSQ(int winning)
{
  int i, j;
  for (i=0;i<8;i++)
	for (j=0;j<8;j++)
	{
	  pcsq[winning][5][i][j] = endgameWinningKing[i][j];
	  pcsq[!winning][5][i][j] = endgameLosingKing[i][j];
	}
  initPiecescores();
}

void printPC(void)
{
 
 int i,j;
  int scw, scb;
  scw=scb=0;

  for (i=0;i<8;i++)
    for (j=0;j<8;j++)
      if (pos.board[i][j].piece!=EMPTY)
        if (pos.board[i][j].colour==WHITE)
          scw+=pcsq[WHITE][pos.board[i][j].piece-1][i][j];
        else
          scb+=pcsq[BLACK][pos.board[i][j].piece-1][i][j];

  printf("White: Piecescores: %d PCSQ: %d\n",piecescores[WHITE], scw);
  printf("Black: Piecsscores: %d PCSQ: %d\n",piecescores[BLACK], scb);
  exit(1);
}

void printPCS(void)
{
 
 int i,j;
  int scw, scb;
  scw=scb=0;

  for (i=0;i<8;i++)
    for (j=0;j<8;j++)
      if (pos.board[i][j].piece!=EMPTY)
        if (pos.board[i][j].colour==WHITE)
          scw+=pcsq[WHITE][pos.board[i][j].piece-1][i][j];
        else
          scb+=pcsq[BLACK][pos.board[i][j].piece-1][i][j];

  printf("White: Piecescores: %d PCSQ: %d\n",piecescores[WHITE], scw);
  printf("Black: Piecsscores: %d PCSQ: %d\n",piecescores[BLACK], scb);
}


void initPiecescores (void)
  {
  int i,j;

  piecescores[WHITE] = 0;
  piecescores[BLACK] = 0;

  for (i=0;i<8;i++)
    for (j=0;j<8;j++)
      if (pos.board[i][j].piece != EMPTY)
        piecescores[pos.board[i][j].colour]+=pcsq[pos.board[i][j].colour][pos.board[i][j].piece-1][i][j];
 }


/* Copies the contents of the first bookmove into the second */
void bookMoveCopy(struct BookMove BM1, struct BookMove *BM2)
  {
  BM2->move.from_row = BM1.move.from_row;
  BM2->move.from_column = BM1.move.from_column;
  BM2->move.to_row = BM1.move.to_row;
  BM2->move.to_column = BM1.move.to_column;
  BM2->move.piece = BM1.move.piece;
  BM2->move.promote = BM1.move.promote;
  BM2->me = BM1.me;
  BM2->next = BM1.next;
  BM2->up = BM1.up;
  BM2->value = BM1.value;
  }

/* Copies the contents of the first move into the second */
void moveCopy(struct Move M1, struct Move *M2)
  {
  M2->from_row = M1.from_row;
  M2->from_column = M1.from_column;
  M2->to_row = M1.to_row;
  M2->to_column = M1.to_column;
  M2->piece = M1.piece;
  M2->promote = M1.promote;
  }

/* returns true if the given moves are identical */
int moveCompare(struct Move M1, struct Move M2)
  {
  if ((M1.from_row == M2.from_row) && (M1.from_column == M2.from_column) && (M1.to_row == M2.to_row) && (M1.to_column == M2.to_column) && (M1.piece == M2.piece) && (M1.promote == M2.promote))
    return TRUE;
  else
    return FALSE;
  }
  
/* provides the checksum for a single square.
 * return value will always be in the range 0-12 and
 * thus can be stored with 4 bits 
 */ 
int squareChecksum (struct Square item)
  {
  if (item.piece==EMPTY) return 0;
  return item.piece*2-item.colour;
  }
 
/* checksum's the global position. Used in repetition detection 
 * and hashing for comparison purposes. Stores the result in the
 * global checksum string. Called to initialize the checksum 
 * string at the start of each new game.
 */
void positionChecksum (void)
{
int i,j;  

/* each square gets 4 bits in the checksum table */
for (i=0;i<8;i++)
  for (j=0;j<8;j+=2)
    {
    posChecksum[(i*4)+(j/2)] = squareChecksum(pos.board[i][j]);
    posChecksum[(i*4)+(j/2)] = posChecksum[(i*4)+(j/2)] << 4;
    posChecksum[(i*4)+(j/2)] += squareChecksum(pos.board[i][j+1]);
    }
}  

/* updates the given square in the 
 * global position checksum used for repetition detection. This
 * function is called during move makes and unmakes.
 */
void updateChecksum (int row, int column)
  {
  int spot = (row*4)+column/2;
  char leftmask = 15;
  char rightmask = 240;
  char check;

  if (column%2==0)
    {
    /* even columns get first 4 bits */
    posChecksum[spot] = posChecksum[spot] & leftmask; 
    check = squareChecksum(pos.board[row][column]);
    posChecksum[spot] = posChecksum[spot] | check<<4;
    }
  else
    {
    /* odd columns get the last 4 bits */
    posChecksum[spot] = posChecksum[spot] & rightmask;
    check = squareChecksum(pos.board[row][column]);
    posChecksum[spot] = posChecksum[spot] | check;
    }
  }
    









