/* These are the pierre's routines which draw the board as text
   to stdout */


// For drawing the board, returns the letter associated with the
// piece on the given square in the global position.
char letter(int row, int column)
  {
  if ((pos.board[row][column].piece == PAWN) && (pos.board[row][column].colour == WHITE))
    return 'P';
  else if ((pos.board[row][column].piece == PAWN) && (pos.board[row][column].colour == BLACK))
    return 'p';
  else if ((pos.board[row][column].piece == ROOK) && (pos.board[row][column].colour == WHITE))
    return 'R';
  else if ((pos.board[row][column].piece == ROOK) && (pos.board[row][column].colour == BLACK))
    return 'r';
  else if ((pos.board[row][column].piece == BISHOP) && (pos.board[row][column].colour == WHITE))
    return 'B';
  else if ((pos.board[row][column].piece == BISHOP) && (pos.board[row][column].colour == BLACK))
    return 'b';
  else if ((pos.board[row][column].piece == KNIGHT) && (pos.board[row][column].colour == WHITE))
    return 'N';
  else if ((pos.board[row][column].piece == KNIGHT) && (pos.board[row][column].colour == BLACK))
    return 'n';
  else if ((pos.board[row][column].piece == QUEEN) && (pos.board[row][column].colour == WHITE))
    return 'Q';
  else if ((pos.board[row][column].piece == QUEEN) && (pos.board[row][column].colour == BLACK))
    return 'q';
  else if ((pos.board[row][column].piece == KING) && (pos.board[row][column].colour == WHITE))
    return 'K';
  else if ((pos.board[row][column].piece == KING) && (pos.board[row][column].colour == BLACK))
    return 'k';
  else
    return ' ';
  }

// Another procedure for drawing the board. Draws the given row (or rank)
// in the global position
void drawrow(int row)
  {
  int column = 0;

  for (column=0;column<8;column++)
    {
    printf("* ");
    printf("%c",letter(row,column));
    if (column == 7)
      printf(" *");
    else
      printf(" ");
    }
  }

// This procedure draws the board on the screen. Note that this routine
// is only temporary and is only here for testing purposes.
void drawBoard()
  {
  float edge = (float)(piecescores[WHITE]-piecescores[BLACK])/100;
  float eval = (float)evaluate(WHITE)/100;


  collectStats();
  printf("\n\n");
  printf("    A   B   C   D   E   F   G   H  \n");
  printf("  *********************************\n");
  printf("8 ");
  drawrow(7);
  printf("\n");
  printf("  *********************************      Black:\n");
  printf("7 ");
  drawrow(6);
  printf("        # of Pieces:   %d\n",stats.num_black_pieces);
  printf("  *********************************        Strength:      %d (%d)\n",stats.black_strength, piecescores[BLACK]);
  printf("6 ");
  drawrow(5);
  if (pos.who_moves==BLACK)
    printf("        # Valid Moves: %d\n",stats.num_black_moves);
  else 
    printf("        # Valid Moves: X\n");
  printf("  *********************************\n");
  printf("5 ");
  drawrow(4);
  printf("      White:\n");
  printf("  *********************************        # of Pieces:   %d\n",stats.num_white_pieces);
  printf("4 ");
  drawrow(3);
  printf("        Strength:      %d (%d)\n",stats.white_strength, piecescores[WHITE]);
  if (pos.who_moves == WHITE)
    printf("  *********************************        # Valid Moves: %d\n",stats.num_white_moves);
  else
    printf("  *********************************        # Valid Moves: X\n");
  printf("3 ");
  drawrow(2);
  printf("\n");
  printf("  *********************************\n"); 
  printf("2 ");
  drawrow(1);
  printf("\n");
  if (edge>=0)
    printf("  *********************************       PosEdge: +%.2f P [white]\n",edge);
  else 
    printf("  *********************************       PosEdge: %.2f P [white]\n",edge);
  printf("1 ");
  drawrow(0);
  if (eval>=0)
    printf("       Eval:    +%.2f P\n", eval);
  else
    printf("       Eval:    %.2f P\n",eval);
  printf("  *********************************");
 if (stats.white_in_check)
    printf("       White is in CHECK");
  if (stats.black_in_check)
    printf("       Black is in CHECK");
  printf("\n");
  fflush(stdout);
  }










