
/* Returns true if a draw is favorable for the given colour */
int drawGood(int colour)
  {
  if (colour==WHITE)
    {
    if (stats.black_strength-stats.white_strength>10)
      return TRUE;
    }
  else if (colour==BLACK)
    {
    if (stats.white_strength-stats.black_strength>10)
       return TRUE;
    }
  return FALSE;
  }

/* returns true if there is a pawn of the given colour on row, column */
int pawnThere(int row, int column, int colour)
  {
  if ((pos.board[row][column].piece==PAWN)&&(pos.board[row][column].colour==colour))
    return TRUE;
  return FALSE;
  }

/* returns the amount to subtract for the given colour due to king safely issues */
int evalKing(int colour)

  {
  int kR, kC;
  int deduct = 0;

  if (colour==WHITE) {kR=pos.wKingRow; kC=pos.wKingColumn;}
  else {kR=pos.bKingRow; kC=pos.bKingColumn;}

  if (colour==WHITE)
    {
    if (kR != 0) return 30;          /* king not on back rank */
    
    if ((kC==4)||(kC==6)||(kC==7)||(kC==5)) /* right side of the board */           
      {
      if (pawnThere(1,5,WHITE)&&pawnThere(1,6,WHITE)&&pawnThere(1,7,WHITE)) deduct-=5;
      else if (pawnThere(1,5,WHITE)&&pawnThere(1,6,WHITE)&&pawnThere(2,7,WHITE)) deduct-=3;
      else if (pawnThere(2,5,WHITE)&&pawnThere(1,6,WHITE)&&pawnThere(1,7,WHITE)) deduct-=1;
      else if (pawnThere(2,5,WHITE)&&pawnThere(1,6,WHITE)&&pawnThere(2,7,WHITE)) deduct+=1;
      else if (pawnThere(1,5,WHITE)&&pawnThere(2,6,WHITE)&&pawnThere(1,7,WHITE)) deduct+=1;
      else if (pawnThere(1,6,WHITE)&&pawnThere(1,7,WHITE)) deduct+=3;
      else deduct+=20;
      }
    else if ((kC==2)||(kC==3))
      {
      if (pawnThere(1,1,WHITE)&&pawnThere(1,2,WHITE)&&pawnThere(1,3,WHITE)) deduct-=5;
      else if (pawnThere(2,1,WHITE)&&pawnThere(1,2,WHITE)&&pawnThere(1,3,WHITE)) deduct-=3;
      else if (pawnThere(1,1,WHITE)&&pawnThere(2,2,WHITE)&&pawnThere(1,3,WHITE)) deduct+=7;
      else if (pawnThere(1,1,WHITE)&&pawnThere(1,2,WHITE)&&pawnThere(2,3,WHITE)) deduct+=3;
      else deduct+=20;
      }
    else if ((kC==1)||(kC==0))
      {
      if (pawnThere(1,0,WHITE)&&pawnThere(1,1,WHITE)&&pawnThere(1,2,WHITE)) deduct-=5;
      else if (pawnThere(2,0,WHITE)&&pawnThere(1,1,WHITE)&&pawnThere(1,2,WHITE)) deduct-=3;
      else if (pawnThere(1,0,WHITE)&&pawnThere(2,1,WHITE)&&pawnThere(1,2,WHITE)) deduct+=1;
      else if (pawnThere(1,0,WHITE)&&pawnThere(1,1,WHITE)&&pawnThere(2,2,WHITE)) deduct-=1;
      else deduct+=20;
      }
    }
  else if (colour==BLACK)
    {
    if (kR != 7) return 30;          /* king not on back rank */
    
    if ((kC==4)||(kC==6)||(kC==7)||(kC==5)) /* right side of the board */           
      {
      if (pawnThere(6,5,BLACK)&&pawnThere(6,6,BLACK)&&pawnThere(6,7,BLACK)) deduct-=5;
      else if (pawnThere(6,5,BLACK)&&pawnThere(6,6,BLACK)&&pawnThere(5,7,BLACK)) deduct-=3;
      else if (pawnThere(5,5,BLACK)&&pawnThere(6,6,BLACK)&&pawnThere(6,7,BLACK)) deduct-=1;
      else if (pawnThere(5,5,BLACK)&&pawnThere(6,6,BLACK)&&pawnThere(5,7,BLACK)) deduct+=1;
      else if (pawnThere(6,5,BLACK)&&pawnThere(5,6,BLACK)&&pawnThere(6,7,BLACK)) deduct+=1;
      else if (pawnThere(6,6,BLACK)&&pawnThere(6,7,BLACK)) deduct+=3;
      else deduct+=20;
      }
    else if ((kC==2)||(kC==3))
      {
      if (pawnThere(6,1,BLACK)&&pawnThere(6,2,BLACK)&&pawnThere(6,3,BLACK)) deduct-=5;
      else if (pawnThere(5,1,BLACK)&&pawnThere(6,2,BLACK)&&pawnThere(6,3,BLACK)) deduct-=3;
      else if (pawnThere(6,1,BLACK)&&pawnThere(5,2,BLACK)&&pawnThere(6,3,BLACK)) deduct+=7;
      else if (pawnThere(6,1,BLACK)&&pawnThere(6,2,BLACK)&&pawnThere(5,3,BLACK)) deduct+=3;
      else deduct+=20;
      }
    else if ((kC==1)||(kC==0))
      {
      if (pawnThere(6,0,BLACK)&&pawnThere(6,1,BLACK)&&pawnThere(6,2,BLACK)) deduct-=5;
      else if (pawnThere(5,0,BLACK)&&pawnThere(6,1,BLACK)&&pawnThere(6,2,BLACK)) deduct-=3;
      else if (pawnThere(6,0,BLACK)&&pawnThere(5,1,BLACK)&&pawnThere(6,2,BLACK)) deduct+=1;
      else if (pawnThere(6,0,BLACK)&&pawnThere(6,1,BLACK)&&pawnThere(5,2,BLACK)) deduct-=1;
      else deduct+=20;
      }
    }


  return deduct;
  }

/* evalutes the global position from the given colour's perspective */
int evaluate(int colour)
  {
  int score = 0;
  int i,j;
  int countw, countb;
  long evalStartTime, evalEndTime;
  long start1,start2,start3;

  checkTime();

  numevaluated++;
  evalStartTime=getMS();

  /* First we check for mate or stalemate */ 
  if (pos.who_moves == BLACK)
    {
    if(!has_move())
      {
      if (check_for_check(BLACK))
	{
	/* black is checkmated */
	if (colour == BLACK)
	  return -10000;
	else
	  return 10000;
	}
      else
        {
	/* black is stalemated */
        if (colour==BLACK && drawGood(BLACK)) return 5000;
        else if (colour==WHITE && drawGood(WHITE)) return 5000;
        else return -5000;
	}
      }
    }
  else
    {
    if(!has_move())
      {
      if (check_for_check(WHITE))
	{
	  /* white is checkmated */
	if (colour == WHITE)
	  return -10000;
	else
	  return 10000;
	}
      else
	{
	/* white is stalemated */
        if (colour==WHITE && drawGood(WHITE)) return 5000;
        else if (colour==BLACK && drawGood(BLACK)) return 5000;
        else return -5000;
	}
      }
    }
 
  start1=getMS();
  time1+=(double)(start1-evalStartTime)/(double)1000;

  /* check for draw by repetition */
  if (checkRepetition(&replist)>=3)
    {
    if (drawGood(colour))
      return 5000;
    else
      return -5000;
    }

  start2=getMS();
  time2+=(double)(start2-start1)/(double)1000;

  /* now we add up the material scores using the PCSQ table.
   * These scores are calculated dynamically during make() and unmake().
   */
  score += piecescores[colour];
  score -= piecescores[!colour]; 

  /* deduct 10 points for every set of doubled pawns */
  for (i=0;i<8;i++)
    {
    countw = 0;
    countb = 0;
    for (j=0;j<8;j++)
      {
      if (pos.board[j][i].piece == PAWN)
        {
        if (pos.board[j][i].colour == WHITE)
          countw++;
        else
          countb++;
        }
      }
    if ((colour == WHITE) && (countw >= 2))
      score -= 10 * (countw-1);
    else if ((colour == BLACK) && (countb >= 2))
      score -= 10 * (countb-1);
    else if ((colour == WHITE) && (countb >= 2))
      score += 10 * (countb-1);
    else if ((colour == BLACK) && (countw >= 2))
      score += 10 * (countw-1);
    }
  
  start3=getMS();
  time3+=(double)(start3-start2)/(double)1000;

  /* now add a bonus if castled or penalize if a move has taken place
     which prevents it (the king has moved)                           */
  /* higher score for castling earlier */
  if (pos.wcastle)
    if (colour == WHITE)
      score += 20+max(0,(20-pos.wcastle));  
    else
      score -= 20+max(0,(20-pos.wcastle));
  else if (pos.bcastle)
    if (colour == BLACK)
      score += 20+max(0,(20-pos.bcastle));
    else
      score -= 20+max(0,(20-pos.bcastle));
  if ((!pos.wcastle) && ((pos.wKing) || (pos.wkRook) || (pos.wqRook)))
    if (colour == WHITE)
      score -= 15;
    else
      score += 15;
  else if ((!pos.bcastle) && ((pos.bKing) || (pos.bkRook) || (pos.bqRook)))
    if (colour == BLACK)
      score -= 15;
    else
      score += 15;

  /* evaluate king safety */
  if (colour == WHITE) { score -= evalKing(WHITE); score += evalKing(BLACK); }
  else { score -= evalKing(BLACK); score += evalKing(WHITE); }

  time4+=(double)(getMS()-start3)/(double)1000;  
  evalEndTime=getMS();
  timeEvaluating += (double)(evalEndTime-evalStartTime)/(double)1000;
  return score;
  }










