/* The chess function headers for Pierre.c */
/* This is not a full list. For function descriptions see the */
/* appropriate file.                                          */

void test(void);
void updatePCSQ(int colour);
int toNumber(char digit);
void updateChecksum (int row, int column);
void positionChecksum (void);
int squareChecksum (struct Square item);
void clearChecksumList (struct ChecksumList *csl);
void deleteChecksum (struct ChecksumList *csl);
void addChecksum (struct ChecksumList *csl);
void initChecksumList (struct ChecksumList *csl);
void initBookList (struct BookMoveList *bml);
void bookMoveCopy(struct BookMove BM1, struct BookMove *BM2);
struct BookMove getBookMove (struct BookMoveList bml);
void clearBookList (struct BookMoveList *bml);
void deleteBookMove (struct BookMoveList *bml);
void bookListCopy (struct BookMoveList bml1, struct BookMoveList *bml2);
void appendBookMove (struct BookMove mov, struct BookMoveList *bml);
void addBookMove (struct BookMove mov, struct BookMoveList *bml);
int check_for_attack(int row, int column, int colour);
void moveCopy(struct Move M1, struct Move *M2);
void initPCSQ(void);
void initList (struct MoveList *ml);
void addMove (struct Move mov, struct MoveList *ml);
void appendMove (struct Move mov, struct MoveList *ml);
void listCopy (struct MoveList ml1, struct MoveList *ml2);
void deleteMove (struct MoveList *ml);
void clearList (struct MoveList *ml);
struct Move getMove (struct MoveList ml);
void moveCopy(struct Move M1, struct Move *M2);
void initBoard(void);
int has_move(void);
int max (int one, int two);
void promote_pawn (int row, int column, int piece);
void makeMove (struct Move *mov);
void unmakeMove(struct Move mov);
int pieces_between(struct Move mov);
int valid_move(struct Move mov);
int check_for_attack(int row, int column, int colour);
int check_for_check(int colour);
int will_check(struct Move mov);
int count_valid_moves(void);
void collectStats(void);
int good_move(struct Move mov);
struct Move randomMove(int who_moves);
void generateMoves(struct MoveList *ml, int mode);
int evaluate(int colour);
int searchLayer(int depth, int colour, int bestmax, int bestmin);
struct Move bestMove(int who_moves, int depth, int bestmax, int bestmin);
struct Move parseMoveInput (char *input);
void createMoveOutput (struct Move mov, char *move);
int checkEndgame (int who_moves);
void reverseList (struct MoveList m1, struct MoveList *m2);
struct Move think();
void searchList (struct MoveList *ml, int type, int value);
void printSearchStats (void);
void printMoveList (struct MoveList *ml);
void genMoves(struct MoveList *ml, int mode);
void showBitboards(void);
void compBitboards(void);
void drawBitboard (bitboard source);
void setupKingPCSQ(int winning);
void printPC(void);
void initPiecescores (void);
void printPer(void);
void printPV (struct MoveList ml);
void createAlgebraOutput(struct Move mov, char *move);
void storePV(struct Move newMove, int depth);
void moveBack(int x);
void clearLine(int x);
void sortList(struct Move mov, struct MoveList *ml);
void printWhisper (int mode, int score);
void outTime(long int ms);
long getMS(void);
int checkRepetition (struct ChecksumList *csl);
int bookSearch(struct MoveList moves, struct BookMoveList *options);








