/* These are all the routines required to check if a move is valid */



/* Check for check 2 is an attempt at a faster algorithm....
 */
int check_for_check(int colour)
  {
  int king_row, king_column;
  int i,j;


  /* first we want to find the target king's location */
  if (colour==WHITE)
    {
    king_row=pos.wKingRow;
    king_column=pos.wKingColumn;
    }
  else
    {
    king_row=pos.bKingRow;
    king_column=pos.bKingColumn;
    } 


  /* Next,.. check for pawn attacks,.. there are only 2 possible places for a pawn 
   * to be situated reletive to the king in order to give check...
   */
   if (colour==WHITE && king_row<6)
     {
     if (pos.board[king_row+1][king_column+1].piece==PAWN&&pos.board[king_row+1][king_column+1].colour==!colour&&king_column<7)
       return TRUE;
     else if (pos.board[king_row+1][king_column-1].piece==PAWN&&pos.board[king_row+1][king_column-1].colour==!colour&&king_column>0)
       return TRUE;
     }
   else if (colour==BLACK && king_row>1)
     {
     if (pos.board[king_row-1][king_column+1].piece==PAWN&&pos.board[king_row-1][king_column+1].colour==!colour&&king_column<7)
       return TRUE;
     else if (pos.board[king_row-1][king_column-1].piece==PAWN&&pos.board[king_row-1][king_column-1].colour==!colour&&king_column>0)
       return TRUE;  
     }

 
  /* The knight attacks are even more trivial to detect! ... */
  if (knightAttacks[king_row*8+king_column]&position[KNIGHT-1][!colour]) return TRUE;

  /* And the king attacks...  */
  if (kingAttacks[king_row*8+king_column]&position[KING-1][!colour]) return TRUE;

  /* Now the sliding piece attacks are found by radiating out from the king's position in the 8
   * possible sliding directions and seeing what the first piece hit is...
   */

  /* 1. Up */
  j=king_column;
  for (i=king_row+1;i<8;i++)
    {
    if (pos.board[i][j].piece!=EMPTY)
      {
      if (pos.board[i][j].colour==colour) break;
      else if ((pos.board[i][j].piece==QUEEN)||(pos.board[i][j].piece==ROOK)) return TRUE;
      else break;
      }
    }
 /* 2. Down */
  j=king_column;
  for (i=king_row-1;i>=0;i--)
    {
    if (pos.board[i][j].piece!=EMPTY)
      {
      if (pos.board[i][j].colour==colour) break;
      else if (pos.board[i][j].piece==QUEEN||pos.board[i][j].piece==ROOK) return TRUE;
      else break;
      }
    }
 /* 3. RIght */
  i=king_row;
  for (j=king_column+1;j<8;j++)
    {
    if (pos.board[i][j].piece!=EMPTY)
      {
      if (pos.board[i][j].colour==colour) break;
      else if (pos.board[i][j].piece==QUEEN||pos.board[i][j].piece==ROOK) return TRUE;
      else break;
      }
    }
 /* 4. Left */
  i=king_row;
  for (j=king_column-1;j>=0;j--)
    {
    if (pos.board[i][j].piece!=EMPTY)
      {
      if (pos.board[i][j].colour==colour) break;
      else if (pos.board[i][j].piece==QUEEN||pos.board[i][j].piece==ROOK) return TRUE;
      else break;
      }
    }
 /* 5. Up-Right Diagonal */
  for (i=king_row+1,j=king_column+1;i<8&&j<8;i++,j++)
    {
    if (pos.board[i][j].piece!=EMPTY)
      {
      if (pos.board[i][j].colour==colour) break;
      else if (pos.board[i][j].piece==QUEEN||pos.board[i][j].piece==BISHOP) return TRUE;
      else break;
      }
    }
 /* 6. Up-Left Diagonal */
  for (i=king_row+1,j=king_column-1;i<8&&j>=0;i++,j--)
    {
    if (pos.board[i][j].piece!=EMPTY)
      {
      if (pos.board[i][j].colour==colour) break;
      else if (pos.board[i][j].piece==QUEEN||pos.board[i][j].piece==BISHOP) return TRUE;
      else break;
      }
    }
 /* 7. Down-Left Diagonal */
  for (i=king_row-1,j=king_column-1;i>=0&&j>=0;i--,j--)
    {
    if (pos.board[i][j].piece!=EMPTY)
      {
      if (pos.board[i][j].colour==colour) break;
      else if (pos.board[i][j].piece==QUEEN||pos.board[i][j].piece==BISHOP) return TRUE;
      else break;
      }
    }
 /* 8. Down-Right Diagonal */
  for (i=king_row-1,j=king_column+1;i>=0&&j<8;i--,j++)
    {
    if (pos.board[i][j].piece!=EMPTY)
      {
      if (pos.board[i][j].colour==colour) break;
      else if (pos.board[i][j].piece==QUEEN||pos.board[i][j].piece==BISHOP) return TRUE;
      else break;
      }
    }
  /* If we haven't found check yet,... then it doesn't exist! */
  return FALSE;
  }


/* returns true if there are pieces between the 2 given squares
 * returns false otherwise
 */
int pieces_between(struct Move mov)
  {
  int i,j;
  int startr, endr, startc, endc;

  /* 1. If the given squares are in the same row */
  if (mov.from_row==mov.to_row)
    {
    if (mov.from_column<mov.to_column)
      {
      startc = mov.from_column;
      endc = mov.to_column;
      }
    else
      {
      startc = mov.to_column;
      endc = mov.from_column;
      }
    for (i=startc+1;i<endc;i++)
      {
      if ((pos.board[mov.from_row][i].piece > 0))
	return TRUE;
      }
    return FALSE;
    }

  /* 2. If the given squares are in the same column */
  if (mov.from_column==mov.to_column)
    {
    if(mov.from_row<mov.to_row)
      {
      startr = mov.from_row;
      endr = mov.to_row;
      }
    else
      {
      startr = mov.to_row;
      endr = mov.from_row;
      }
    for (i=startr+1;i<endr;i++)
      {
      if ((pos.board[i][mov.from_column].piece > 0))
	return TRUE;
      }
    return FALSE;
    }

  /* 3. The given squares are on the same diagonal */
  if ( ((mov.to_column-mov.from_column)==(mov.to_row-mov.from_row)) || ((mov.to_column-mov.from_column)==-(mov.to_row-mov.from_row)))   // same diagonal
    {
    if(((mov.from_column<mov.to_column) && (mov.from_row<mov.to_row)) || ((mov.from_column>mov.to_column) && (mov.from_row>mov.to_row)))
      {
      /* up and to the right (or opposite) */
      if (mov.from_column<mov.to_column)
	{
	startr = mov.from_row;
	endr = mov.to_row;
	startc = mov.from_column;
	endc = mov.to_column;
	}
      else
	{
	startr = mov.to_row;
	endr = mov.from_row;
	startc = mov.to_column;
	endc = mov.from_column;
	}
      j=startc;
      for (i=startr+1;i<endr;i++)
	{
	j++;
	if (pos.board[i][j].piece > 0)
	  return TRUE;
	}
      return FALSE;
      }
    if(((mov.from_column<mov.to_column) && (mov.from_row>mov.to_row)) || ((mov.from_column>mov.to_column) && (mov.from_row<mov.to_row)))
      {
      /* up and to the left (or opposite) */
      if (mov.from_column<mov.to_column)
	{
	startr = mov.from_row;
	endr = mov.to_row;
	startc = mov.from_column;
	endc = mov.to_column;
	}
      else
	{
	startr = mov.to_row;
	endr = mov.from_row;
	startc = mov.to_column;
	endc = mov.from_column;
	}
      j=startc;
      for (i=startr-1;i>endr;i--)
	{
	j++;
	if (pos.board[i][j].piece > 0)
	  return TRUE;
	}
      return FALSE;
      }
    }
  return FALSE;      /* the given squares are not aligned */
  }

/* checks to see if the given move is a valid one. returns true/false
 * correspondingly. By valid I mean "by DEFINITION, can the piece move
 * to that square?". It does NOT take into consideration whether or not
 * the user will be in check afterwards. The only time it considers if
 * the user is currently in check is when castling, as it is the only
 * move which is illegal to make while in check.
 */
int valid_move(struct Move mov)
  {
  /* first check if there is a piece of the same colour on
   * the target square
   */
  if ((pos.board[mov.from_row][mov.from_column].colour == pos.board[mov.to_row][mov.to_column].colour) && (pos.board[mov.to_row][mov.to_column].piece > 0))
    return FALSE;    // cant move to an already occupied square
  if (pos.board[mov.from_row][mov.from_column].piece == ROOK)
    {
    if ((mov.from_column==mov.to_column) || (mov.from_row==mov.to_row))
      if (!pieces_between(mov))
	return TRUE;
    return FALSE;
    }
  if (pos.board[mov.from_row][mov.from_column].piece == BISHOP)
    {
    if (((mov.to_column-mov.from_column)==(mov.to_row-mov.from_row)) || ((mov.to_column-mov.from_column)==-(mov.to_row-mov.from_row)))
      if (!pieces_between(mov))
	return TRUE;
    return FALSE;
    }
  if (pos.board[mov.from_row][mov.from_column].piece == QUEEN)
    {
    if ( ((mov.from_column==mov.to_column) || (mov.from_row==mov.to_row)) || (((mov.to_column-mov.from_column)==(mov.to_row-mov.from_row)) || ((mov.to_column-mov.from_column)==-(mov.to_row-mov.from_row))) )
      if (!pieces_between(mov))
	return TRUE;
    return FALSE;
    }
  if (pos.board[mov.from_row][mov.from_column].piece == KNIGHT)
    {
    if ( ((fabs(mov.to_column-mov.from_column)==2) && (fabs(mov.to_row-mov.from_row)==1)) || ((fabs(mov.to_row-mov.from_row)==2) && (fabs(mov.to_column-mov.from_column)==1)))
      return TRUE;   /* knights can jump over pieces so it
		      * doesn't matter if there are pieces
		      * in the way.
		      */
    return FALSE;
    }
  if (pos.board[mov.from_row][mov.from_column].piece == PAWN)
    {
    if (pos.board[mov.from_row][mov.from_column].colour == WHITE)
      {
      if (((mov.to_row-mov.from_row)==1) && ((mov.from_column-mov.to_column)==0))
	/* trying to move forward one square */
	if (pos.board[mov.to_row][mov.from_column].piece == EMPTY)
	  return TRUE;
      if ( ((mov.to_row-mov.from_row)==1) && (fabs(mov.to_column-mov.from_column)==1) )
	{
	/* trying to kill diagonally */
	if ((pos.board[mov.to_row][mov.to_column].colour == BLACK) && (pos.board[mov.to_row][mov.to_column].piece != EMPTY))
	  return TRUE;
	else if (pos.board[mov.to_row][mov.to_column].piece == EMPTY)
	  {
	  /* EN PASSENT conditions: 1) there must be a pawn of the
	   * opposite colour on the square directly behind where he wants
	   * to move (beside him now) & 2) that pawn must have gotten there
	   * via an initial move of 2 squares on the previous move.
	   */
	  if ((pos.board[mov.to_row-1][mov.to_column].piece == PAWN) && (pos.board[mov.to_row-1][mov.to_column].colour == BLACK))
	    if (pos.ippawn==mov.to_column && mov.to_row==5)
	      return TRUE;
	  }
	}
      if ( ((mov.to_row-mov.from_row)==2) && ((mov.to_column-mov.from_column)==0) && (mov.from_row==1))
	{
        /* an initial move of 2 pieces */
	if (!pieces_between(mov))
	  if (pos.board[mov.to_row][mov.to_column].piece == 0)
	    return TRUE;
	}
      return FALSE;
      }
    if (pos.board[mov.from_row][mov.from_column].colour == BLACK)
      {
      if (((mov.to_row-mov.from_row)==-1) && ((mov.from_column-mov.to_column)==0))
        /* trying to move forward */
	if (pos.board[mov.to_row][mov.from_column].piece == 0)
	  return TRUE;
      if (((mov.to_row-mov.from_row)==-1) && (fabs(mov.to_column-mov.from_column)==1) )
	{
	/* trying to kill diagonally */
	if ((pos.board[mov.to_row][mov.to_column].colour == WHITE) && (pos.board[mov.to_row][mov.to_column].piece > 0))
	  return TRUE;
	else if (pos.board[mov.to_row][mov.to_column].piece == EMPTY)
	  {
          /* EN PASSENT conditions: see above under white */
	  if ((pos.board[mov.to_row+1][mov.to_column].piece == PAWN) && (pos.board[mov.to_row+1][mov.to_column].colour == WHITE))
	    if (pos.ippawn==mov.to_column && mov.to_row==2)
	      return TRUE;
	  }
	}
      if ( ((mov.from_row-mov.to_row)==2) && ((mov.to_column-mov.from_column)==0) && (mov.from_row==6))
	/* an initial move of 2 squares */
	if (!pieces_between(mov))
	  if (pos.board[mov.to_row][mov.to_column].piece == 0)
	    return TRUE;
      return FALSE;
      }
    }
  if (pos.board[mov.from_row][mov.from_column].piece == KING)
    {
    if (((fabs(mov.to_row-mov.from_row)==1) && (fabs(mov.to_column-mov.from_column)<=1)) || ((fabs(mov.to_column-mov.from_column)==1) && (fabs(mov.to_row-mov.from_row)<=1)))
      return TRUE;    /* normal king move of one square */
    if ( (fabs(mov.to_column-mov.from_column)==2) && (mov.to_row-mov.from_row==0))
      {
      /* --------------> CASTLING! All castling conditions except for being
       * in check afterwards are checked here with different cases for the
       * different colours and king/queenside. The conditions checked for
       * are as follows: 1) has the king moved? 2) has the corresponding
       * rook moved? 3) are the squares between the king and the rook
       * empty? 4) will the king be moving through check? (this is checked
       * by ensuring that the square directly beside the king in the
       * direction he will be moving is not under attack by the other side)
       * 5) is the player currently in check? If all these conditions hold,
       * then the move is a valid move <-----------------------------------
       */
      if (pos.board[mov.from_row][mov.from_column].colour == WHITE)
	{
	if ((pos.wKing != 0) || (stats.white_in_check == TRUE))
          return FALSE;           /* king has moved or is in check */
	if (mov.to_column == 6)   /* kingside for white */
	  {
	    //if (mov.from_row==0)
	  if (pos.wkRook == 0)
	    if ((pos.board[0][6].piece == EMPTY) && (pos.board[0][5].piece == EMPTY))
	      if (!check_for_attack(0, 5, BLACK))
		return TRUE;
	  }
	else if (mov.to_column == 2)   /* queenside for white */
	  {
	    //if (mov.from_row==0)
	  if (pos.wqRook == 0)
	    if ((pos.board[0][1].piece == EMPTY) && (pos.board[0][2].piece == EMPTY) && (pos.board[0][3].piece == EMPTY))
	      if (!check_for_attack(0,3, BLACK))
		return TRUE;
	  }
	}
      if (pos.board[mov.from_row][mov.from_column].colour == BLACK)
	{
	if ((pos.bKing != 0) || (stats.black_in_check == TRUE))
	  return FALSE;         /* king has moved or is in check */
        if (mov.to_column == 6) /* kingside for black */
	  {
	    //if (mov.from_row==0)
	  if (pos.bkRook == 0)
	    if ((pos.board[7][6].piece == EMPTY) && (pos.board[7][5].piece == EMPTY))
	      if (!check_for_attack(7, 5, WHITE))
		return TRUE;
	  }
	else if (mov.to_column == 2) /* queenside for black */
	  {
	    //if (mov.from_row==0)
	  if (pos.bqRook == 0)
	    if ((pos.board[7][1].piece == EMPTY) && (pos.board[7][2].piece == EMPTY) && (pos.board[7][3].piece == EMPTY))
	      if (!check_for_attack(7,3, WHITE))
		return TRUE;
	  }
	}
      }
    return FALSE;    /* it is not a valid king move */
    }
  return FALSE;     /* not a valid piece on the from square */
  }

/* this function will check to see if the given colour is currently
 * attacking the given square. returns true/false appropriately
 */
int check_for_attack(int row, int column, int colour)
  {
  int i,j;
  struct Move tempmove;

  /* now we cycle through and find each piece of the opposite colour
   * and check to see if the given square is a possible move for that
   * piece
   */
  tempmove.to_row = row;
  tempmove.to_column = column;
  for (i=0; i<8; i++)
    {
    for (j=0;j<8;j++)
      {
      if ((pos.board[i][j].colour == colour) && (pos.board[i][j].piece > 0))
	{
	tempmove.from_row = i;
	tempmove.from_column = j;
	if (valid_move(tempmove))
	  return TRUE;
	}
      }
    }
  return FALSE;
  }

/* this function will check to see if the given colour is in check
 * returns true/false appropriately
 */
int check_for_check2(int colour)
  {
  int king_row, king_column;

  /* first we want to find the target king's location */
  if (colour==WHITE)
    {
    king_row=pos.wKingRow;
    king_column=pos.wKingColumn;
    }
  else
    {
    king_row=pos.bKingRow;
    king_column=pos.bKingColumn;
    }  

  if (check_for_attack(king_row,king_column,!colour))
    return TRUE;

  return FALSE;
  }

/* function checks to see if the side to move will be in check after
 * the given move. It is the user's responsiblity to ensure that the
 * given move is valid. Returns true/false.
 */
int will_check(struct Move mov)
  {
  int answer;
  makeMove(&mov);
  answer = check_for_check(!pos.who_moves);
  unmakeMove(mov);
  return answer;
  }


/* All things considered,... is this a valid move?
 * the Definitive function,... returns true/false
 */
int good_move(struct Move mov)
  {
  /* --------->  the move is good if all of the input coordinates
   * are inbounds, there is a piece belonging to the player who's
   * turn it is on the from square, the piece on the from square
   * can move the the target square by definition, and the player
   * won't be in check afterwards. Whether or not the player is
   * currently in check is only relevant if they are trying to
   * castle, and this is handled appropriately in the validmove()
   * function. All of the conditions above are checked in that
   * order below <----------------------------------------------
   */

  if ((mov.from_row>=0) && (mov.from_row<=7) && (mov.to_row>=0) && (mov.to_row<=7))
    if ((mov.from_column>=0) && (mov.from_column<=7) && (mov.to_column>=0) && (mov.to_column<=7))
      if ((pos.board[mov.from_row][mov.from_column].piece > 0) && (pos.board[mov.from_row][mov.from_column].colour == pos.who_moves))
	if (valid_move(mov))
	  if (!will_check(mov))
	    return TRUE;
	  else error = 1;
	else error = 2;
      else error = 3;
    else error = 4;
  else error = 5;

  /* if any of these conditions fail, then the move in INVALID */
  return FALSE;
  }

















